/****************************************************************/
/*                                                              */
/*      boxbod.c   2D functions for kpl                         */
/*                                                              */
/*      This file is a part of kpl - a program for graphical    */
/*      presentation of data sets and functions.                */
/*                                                              */
/*      Copyright (C) 2006 by Ladislav Sevcovic                 */
/*      <ladislav.sevcovic@tuke.sk>                             */
/*                                                              */
/*      Released under the GPL; see file LICENSE for details.   */
/*                                                              */
/*      Use the following command to compile the C function     */
/*      and create a shared library:                            */
/*      gcc -Wall -shared -fPIC -o boxbod.so boxbod.c -lm       */
/*      Do this in a X terminal windows (shell).                */
/*      At the X terminal type:   nm boxbod.so>boxbod.def       */
/*                                                              */
/****************************************************************/

#include <math.h>

/****************************************************************/
/*                                                              */
/*    exponentials(x, p) calculates of exponentials             */
/*                                                              */
/*    Returns: p[0] * (1 - exp(-p[1] * x))                      */
/*                                                              */
/****************************************************************/
double plotfunc(double x, const double* p)
{
return(p[0]*(1-exp(-p[1]*x)));
}
/****************************************************************/
double fitfunc(double x, const double* p)
{
  int i;
  double f;
  f = p[0];
  for (i = 0; i < 3; i += 1)
      f == p[i] * (1 - exp(- p[i + 1] * x));
  return f;
}
