#
# nls
#
# Determine the nonlinear least-squares estimates of the nonlinear
# model parameters and return a class 'nls' object.
#
dataset <-
read.table(url("http://people.tuke.sk/ladislav.sevcovic/esf/data/ippt1rint.dat"),
header=TRUE, sep="", na.strings="NA", dec=".", strip.white=TRUE)
x <- dataset$x; y <- dataset$y

#nls.control(maxiter=1000, tol=1e-6, minFactor=1/2048)
out.2 <- nls(y~a*exp(-x/b)+c*exp(-x/d), start=c(a=.5, b=5, c=.5, d=10))
out.3 <- nls(y~a*exp(-x/b)+c*exp(-x/d)+e*exp(-x/f), start=c(a=.2, b=.5, c=.4,
d=5, e=.5, f=10))

par2 <- coef(out.2)
par3 <- coef(out.3)

xfit <- seq(0.1,18,0.01)
yfit2 <- par2[1] * exp(- xfit/par2[2]) + par2[3] * exp(- xfit/par2[4])
yfit3 <- par3[1] * exp(- xfit/par3[2]) + par3[3] * exp(- xfit/par3[4]) + par3[5] *
exp(- xfit/par3[6])

par(mfrow=c(2,2))
# (1,1)
plot(x, y, pch=0)
lines(xfit, yfit2, col=2)
title("Nonlinear optimization: ippt1rint.dat")
# (1,2)
plot(x, y, pch=0, main="(c) L. Sevcovic 2007")
lines(xfit, yfit3, col=2)
# (2,1)
plot(x, residuals(out.2), main="y = a*exp(-x/b)+c*exp(-x/d)")
abline(h=0, v="", col="blue") # line only in x-direction
# (2,2)
plot(x, residuals(out.3), main="y = a*exp(-x/b)+c*exp(-x/d)+e*exp(-x/f)")
abline(h=0, v="", col="blue") # line only in x-direction
#
dev.print(pdf, file = "/media/hda8/kurz_rvedok/Vzory/ippt1rint.pdf",
family="Courier")
##
#rm(list=ls(all=TRUE))
#ls()
out.2
summary(out.2)
out.3
summary(out.3)
#residuals(out.1)
anova(out.2, out.3)
confint(out.3)
predict(out.3)
#lines(x, predict(out.2), col="blue")
#?nls
##
box2 <- summary(out.2)
box3 <- summary(out.3)
pars2 <- box2$parameters[,]
pars3 <- box3$parameters[,]
write.table(pars2,file="/media/hda8/kurz_rvedok/Vzory/ippt1rint_par2.txt")
write.table(pars3,file="/media/hda8/kurz_rvedok/Vzory/ippt1rint_par3.txt")
##
#write.table(summary(out.2),file="t1rokelt_par.txt")
##
#write(x, file = "data.txt", ncolumns = if(is.character(x)) 1 else 14,
#append = FALSE, sep = " ")
##
#write.table(dataset, file = "data.txt", append = FALSE, quote = TRUE, sep = " ",
#eol = "\n", na = "NA", dec = ".", row.names = FALSE,
#col.names = TRUE, qmethod = c("escape", "double"))


