##
clc()
clf()
clear all
	## jeden derivacny zaznam spektra
load caso4_1b.txt;
x = caso4_1b(:,1);
y = caso4_1b(:,2);
	## 16 akumulovanych zaznamov spektra
%load caso4_16.txt;
%x = caso4_16(:,1);
%y = caso4_16(:,2);
	## filtracia FFT
a1 = fftshift(fft(y));
a = fft(fftshift(y));
a1(1:490) = 0;
a1(540:1024) = 0;
y_f1 = real(ifft(fftshift(a1)));
y_f = abs(fftshift(a));
[miny, minxy] = min(y_f1);
[maxy, maxxy] = max(y_f1);
	## konstanty
step = 208;
gamma = 2.67523e08;
h_tr = 1.054e-34;
	## vypocty parametrov spektra hydratu CaSO4.1H2O
u0 = 4*pi*1e-7;
deltaf = (step*(maxxy - minxy));
deltaw = 2*pi*deltaf;
deltaB = deltaw/gamma;
	## vypocet medziprotonovej vzdialenosti v H2O
	## podrobnosti na http://people.tuke.sk/ladislav.sevcovic
r = ((3*gamma*h_tr*u0)/(8*pi*deltaB))^0.33333;
plot(x,y,'-r',x,y_f1,'-b')
box('on')
grid('on')
	## vypis vysledkov
text(50,150,['Delta_B = ' num2str(deltaB*10000) ' G'],'fontsize',14,'rotation',0,'color','k');
text(50,50,['r = ' num2str(r) ' m'],'fontsize',14,'rotation',0,'color','k');
	## ulozenie grafu do suboru
disp(['Vzdialenost protonov = ' num2str(r) ' m'])
disp(['Vzdialenost pikov delta_B = ' num2str(deltaB*10000) ' G'])
print('caso4_fft_1.pdf','-dpdf')