  # --------------------------------------------------------
  # Linearna regresia pre priamku typu y = a + bx s vypoctom
  # standardnych neistot parametrov 'a' a 'b' aj pre pripad
  # znamych neistot 'dy' meranych hodnot 'y'.
  # --------------------------------------------------------
%% graficky vystup programom 'octplot'
%% pred spustenim tohoto skriptu ho aktivujte prikazom:
%toggle_octplot
clc()  % Clear the terminal screen and move the cursor
home() % to the upper left corner
clg()  % Clear the plot window and any titles or axis label.
       % The name 'clg' is aliased to 'clearplot' for
       % compatibility with MATLAB.
clf()
%load /home/laco/work_octave/e6.dat;
%xdata = e6(:,1);
%ydata = e6(:,2);
load norris.dat;
xdata = norris(:,1);
ydata = norris(:,2);
%% fitovanie
  % Generate the standard error 'dy'
  % Use dy=[] if uncertainty is unknown
dy=(1 + rand(size(ydata)))/2;
[p,s] = wpolyfit(xdata,ydata,[],1);
  % Estimate the uncertainty of the polynomial coefficients 'da' and 'db'
dp=sqrt(sumsq(inv(s.R'))'/s.df)*s.normr;
a=p(2); b=p(1);
da=dp(2); db=dp(1);
%%
xfine = linspace(min(xdata),max(xdata),size(xdata));
[fitted_y,dyf] = polyconf(p,xfine,s,'pi');
  % 'ci' confidence interval (range of likely values for the
  % mean at x)
  %
  % 'pi' prediction interval (range of likely values
  % seen when measuring at x)
  %
p_chi2 = 1 - chisquare_cdf(s.normr^2,s.df);
%% graficky vystup
set(gcf,'Color','w');
title(['Fit results: Y = a + b*X \n \n'...
 'a = ' num2str(a) '+/-' num2str(da) ', b = ' num2str(b) '+/-' num2str(db)]);
t1 = get(gca,'title');
set(t1,'fontsize',16,'fontname','serif');
xlabel('Teplota (stupen C)');
ylabel('Odpor vodica (ohm)');
h = plot(xdata,ydata,'sr;expdata;',xfine,fitted_y,'-b;fit;');
%set(gca,'XLim',[20 75],'YLim',[100 127]); % pre data e6.dat
set(gca,'XLim',[0 1100],'YLim',[0 1100]); % pre data norris.dat
%% zmena stylu a symbolov grafiky
set(h,'markersize',4);
yh = get(gca,'ylabel');
set(yh,'fontsize',14);
xh = get(gca,'xlabel');
set(xh,'fontsize',14);
%
text(25,125,['Probability(chi^2 > chi^2(0)) = ' num2str(p_chi2*100) ' %'],'fontsize',12,'rotation',0,'color','k');
%grid('on')
box('on')
%% graficky vystup do suboru
print -dpng -r96 'fitabx_octplot_96.png'
print('fitabx_octplot.png','-dpng')
print('fitabx_octplot.pdf','-dpdf')
p(2); % koeficient 'a' rovnice y = a + b*x
p(1); % koeficient 'b' rovnice y = a + b*x
	    % fitted_y = p(2) + p(1)*xdata
disp("Koeficienty 'a' a 'b':"), disp([p(2), p(1)]);
disp(['Probability(chi^2 > chi^2(0)) = ' num2str(p_chi2*100) ' %']);
%
