%% graficky vystup programom 'octplot'
%% pred spustenim tohoto skriptu ho aktivujte prikazom:
%toggle_octplot
clc()
clg()
clf()
load e6.dat;
xdata = e6(:,1);
ydata = e6(:,2);
	##
start = [.5 .5]; % startovacie hodnoty
%% funkcia fitovania 'fitfun'
% function f = fitfun(x,P)
% # P(1) - parameter 'a'
% # P(2) - parameter 'b'
% f = P(1)+P(2).*x;
% end
%%
[fitted_y,stresid,r2] = leasqr(xdata,ydata,start,'fitfun');
fitdata = [xdata,fitted_y];
expdata = [xdata,ydata];
	## graficky vystup
set(gcf,'Color','w');
title('Teplotna zavislost elektrickeho odporu vodica')
t1 = get(gca,'title')
set(t1,'fontsize',22,'fontname','serif')
xlabel('Teplota (stupen C)')
ylabel('Odpor vodica (ohm)')
h = plot(xdata,ydata,'r.s',xdata,fitted_y,'-b');
grid on
box('on')
set(gca,'XLim',[20 75],'YLim',[100 125]);
	## zmena stylu a symbolov grafiky
set(h,'markersize',4);
yh = get(gca,'ylabel');
set(yh,'fontsize',16);
#
text(30,110,'LLSQ Blue Line','fontsize',16,'rotation',40,'color','r');
	## small graph First
axes();
set(gca(),"position",[0.65,0.3,0.2,0.3]);
set(gca(),"color",[1.0,1.0,0.0]);
	## ticks are not very nice -- zap them
set(gca(),"xtick",[]);
set(gca(),"ytick",[]);
	## put a nice histogram just to show off
hist(randn(100,1),20);
box('on')
	## small graph Second
ram=axes('position',[.45 .2 .15 .15]);
x=linspace(0,2*pi,60); y=sin(x);
title('Sinusovka')
t2 = get(gca,'title')
set(t2,'fontsize',14,'fontname','serif')
plot(x,y,'-r')
set(gca(),'XLim',[0 2*pi],'YLim',[-1.1 1.1]);
set(ram,'box','on','xtick',[0 3.14 6.28],'ytick',[-1.1 -0.5 0 0.5 1.1])
%
print -dpng -r72 'octplot_grafy_72.png'
print('octplot_grafy.png','-dpng')
print('octplot_grafy.pdf','-dpdf')
stresid(1); % koeficient 'a' rovnice y=a+b*x
stresid(2); % koeficient 'b' rovnice y=a+b*x
	    % fitted_y = stresid(1) + stresid(2)*xdata
disp("Koeficienty 'a' a 'b':"), disp(stresid);
%
