  # --------------------------------------------------------
  # Linearna regresia pre priamku typu y = a + bx s vypoctom
  # standardnych neistot parametrov 'a' a 'b' aj pre pripad
  # znamych neistot 'dy' meranych hodnot 'y'.
  # --------------------------------------------------------
%% graficky vystup programom 'gnuplot'
clc()  # Clear the terminal screen and move the cursor
home() # to the upper left corner
load e6.dat;
x=e6(:,1);
y=e6(:,2);
xb=x(1); xe=x(end); yb=y(1); ye=y(end);
  # Generate the standard error 'dy'
  # Use dy=[] if uncertainty is unknown
dy=(1+rand(size(y)))/2;
[p,s] = wpolyfit(x,y,[],1);
  # Estimate the uncertainty of the polynomial coefficients 'da' and 'db'
dp=sqrt(sumsq(inv(s.R'))'/s.df)*s.normr;
a=p(2); b=p(1);
da=dp(2); db=dp(1);
xf = linspace(x(1),x(end),100);
[yf,dyf] = polyconf(p,xf,s,'pi');
  # 'ci' confidence interval (range of likely values for the
  # mean at x)
  #
  # 'pi' prediction interval (range of likely values
  # seen when measuring at x)
  #
p_chi2 = 1 - chisquare_cdf(s.normr^2,s.df);
clg() # Clear the plot window and any titles or axis label.
      # The name 'clg' is aliased to 'clearplot' for
      # compatibility with MATLAB.
hold on;
%% graficky vystup
plot(xf,yf,'g-',xf,yf+dyf,'k.',xf,yf-dyf,'k.',x,y,'xr');
legend('Fit results','Upper limit','Lower limit','Experiment',2);
title(['Fit result: Y = a + b*X \n \n'...
 'a = ' num2str(a) '+/-' num2str(da) ', b = ' num2str(b) '+/-' num2str(db) '\n \n Probability(chi^2 > chi^2(0)) = ' num2str(p_chi2*100) ' %'])
scalex=((max(x)-min(x))*.1); xmin=min(x)-scalex; xmax=max(x)+scalex;
scaley=((max(y)-min(y))*.2); ymin=min(y)-scaley; ymax=max(y)+scaley;
axis([xmin xmax ymin ymax])
xlabel('Teplota (stupen C)')
ylabel('Odpor vodica (ohm)')
%% ulozenie grafu do suboru 'plt' a 'eps'
save "polywfit_gnuplot.plt"
hold off;
__gnuplot_set__ terminal push;
__gnuplot_set__ terminal postscript eps    # set the output mode
__gnuplot_set__ output "polywfit_gnuplot.eps"        # the name of your PostScrip file
replot;
__gnuplot_set__ terminal x11;       # return to default output mode
#__gnuplot_set__ terminal pop;      # return to default output mode
__gnuplot_set__ output;