from scipy.optimize import fmin, fmin_cg
from scipy import *
from pylab import *
    ##  e.g., nonlinear least squares fitting
data = load('boxbod.dat')
    ## for 'misra1a.dat'
#y = data[:,0]
#x = data[:,1]
#xfine = r_[70:760:1]
    ##
x = data[:,0]
y = data[:,1]
xfine = r_[1:11:.1]
    ## Python Source (*.py *.pyw)
    ## 
p0, p1 = 1, 1 # init value for boxbod.dat
#p0, p1 = 250,.0005 # init value for misra1a.dat
def fitting_func(p0, p1, x):
    return p0 * (1-exp(-p1 * x))
    ##
def objective_func(params, data):
    p0, p1 = params  
    sum_of_squares = 0.
    for x, y in data:
         f_of_x = fitting_func(p0, p1, x)
         dy = f_of_x - y
         sum_of_squares += dy*dy
    return sum_of_squares
    ##
print 
print fitting_func(p0, p1, x)
#p_init = array(([250, .0005])) # init value for misra1a.dat
p_init = [100, 0.75] # init value for boxbod.dat
print(objective_func)

    ## minimize by simplex method
#p_opt = scipy.optimize.fmin(objective_func, p_init)
p_opt = fmin(objective_func, p_init,args=(data,))

    ## minimize via conjugate gradient (w or w/o gradient function)
#p_opt = scipy.optimize.fmin_cg(objective_func, p_init, fprime)
#p_opt = optimize.fmin_cg(objective_func, p_init, fprime=None)
print('Optimalne parametre "p0" a "p1":',p_opt)
yfine = p_opt[0] * (1-exp(-p_opt[1] * xfine))
plot(x,y,'sk',x,fitting_func(p0, p1, x),'^r',xfine,yfine,'-b')#,markeredgecolor='k',markerfacecolor='w')
axis([0, 11, 90, 230])
#axis([70, 760, 10, 90])
legend(('True (data)', 'Guest (start value)', 'NLSQ -Fit'),'best')
    # Save figure *.png, *.eps
savefig('boxbod.eps')
show()