from scipy import *
from pylab import *
matplotlib.rc('text', usetex = True)
clf()
## Expdata loading from ascii format
#dt = load('/home/laco/work_pylab/e16_2.dat')
dt = load('e16-1.dat')
x = dt[:,0]
y = dt[:,1]
## Other method for data loading from n-column data format
#x,y = load('/home/laco/work_pylab/e16_2.dat', usecols=(0,1), unpack=True)
## and for two column data format
#x,y = load('/home/laco/work_pylab/e16_2.dat',unpack=True)
## The direct method find the spline representation of a expdata
f = interpolate.splrep(x,y,s=0)
## 'Krokovanie' s presnostou merania mag. prudu Im = 10 mA
krok = 10
xfine = arange(min(x),max(x)+1,krok)
## Evaluating the spline and its derivatives
yfine = interpolate.splev(xfine,f,der=0)
#dyfine = interpolate.splev(xfine,f,der=1)
dy = interpolate.splev(x,f,der=1)
## The direct method find the spline representation of
## a expdata derivatives
df = interpolate.splrep(x,dy,s=0) # splajn reprezentacia ciernych stvorcov
dyfine = interpolate.splev(xfine,df,der=0) # modre body
## Plot experimental data
subplot(211);
plot(x,y,'ok',xfine,yfine,'r-')
rangex = max(x)-min(x);
rangey = max(y)-min(y);
axis([min(x)-rangex/10, max(x)+rangex/15, 0, max(y)+rangey/10])
ylabel('Anodovy prud magnetrona I$_{\mathsf{A}}$ (mA)')
title('Cubic Spline Interpolation - E16')
legend(('True (data)', 'Interpolate'))
## Plot derivation of experimental data
subplot(212);
plot(x,dy,'sk',xfine,dyfine,'-b')
## Vytvorenie dvojic (x,dyfine)
for i in range(len(dyfine)):
	if type(i) != type(1):
		continue
	newdata = (i,dyfine[i])
	#print newdata
## Hladanie min(x,dynew) a krit. hod. prudu magnetom Ik = krprud
for j in range(len(dyfine)):
	if dyfine[j] == min(dyfine):
		krprud = j*krok
		print ''
		print ' x[0] = ', x[0], 'mA' 
		print ' Minimum bolo najdene v tomto bode:', (j,dyfine[j])
		print ' Kriticka hodnota mag. prudu je:', krprud + x[0], 'mA' 
	if not min(dyfine):
		print ' Minimum sa nenaslo!'
##
rangedyf = max(dyfine)-min(dyfine)
axis([min(x)-rangex/10, max(x)+rangex/15,
min(dyfine)-rangedyf/10, max(dyfine)+rangedyf/10])
ylabel('Prva derivacia anod. prudu (-)')
xlabel(r'Prud magnetom I$_{\mathsf{m}}$ (mA)')
prud = " I$_{\mathsf{krit}}$ = %.0f mA" %(krprud + x[0])
text(x[7],min(dyfine),prud,fontsize=12)
## Save figure *.png
savefig('e16-1')
show()