#from scipy import linspace, polyval, polyfit, sqrt, stats, randn
#from pylab import plot, title, show , legend
from scipy import *
#from numpy import *
from pylab import *
from scipy.stats import chi2
matplotlib.rc('text', usetex = True)
	# Expdata loading from ascii format
expdata = load('noint1.dat')
xdata = expdata[:,0]
ydata = expdata[:,1]
	#
	# Linear regression example y = a + b*x
	# This is a very simple example of using two scipy tools 
	# for linear regression, 'polyfit' and 'stats.linregress'
	# Linear regression using 'polyfit';  'polyfit' can be used other orders polys
	#
a = [sum(xdata*ydata)/sum(xdata**2),0]
yfit = polyval(a,xdata) # or yfit = a[0]*xdata
xline = [0, 1.05*max(xdata)-.0*min(xdata)]
yline = polyval(a,xline)
	#
	# Compute the regression coeficient error and mean square error 
	# Ref:
	# 1) John R. Taylor, "An Introduction to Error Analysis", (1st ed., 1982)
	#    Russian translation "Vvedenie v teoriyu oshibok", Moskva, Mir, 1985, p. 166
	# 2) J. Uhrin, L. Sevcovic, J. Murin, "Fyzikalne merania", Kosice, elfa, 2006, p. 129 
	#
n = len(xdata)
norm2 = sum((yfit-ydata)**2) # SQ Sum of Squares
pval = (1 - chi2.cdf(norm2, (n-1)))*100
print('SQ =', norm2)
print('P =', pval)
RSD = sqrt([sum((yfit-ydata)**2)/(n-1)]) # RSD Residual Standard Deviation
                                         # mean square error; sigma y
#sa = sqrt([sum((yfit-ydata)**2)/((n-1)*sum(xdata**2))]) # error of coeficent 'a'
sa = sqrt([(((sum(ydata**2))/(sum(xdata**2))) - a[0]**2)/(n-1)]) # Fyz. merania, str. 129
#
if a[0] >= 0:
	sign = '+'
else:
	sign = '-'
# 
print('')
print('Linear regression y = a*x')
print('Parameters of regression: a = %.6g +/- %.6g, RSD = %.6g' %(a[0],sa,RSD))
print('')
	# Matplotlib ploting
title(r'\textsf{Linear Regression}',size='x-large')
plot(xdata,ydata,'ks',xline,yline,'r-',markersize=6,markeredgecolor='k',\
markerfacecolor='w')
legend(('Exp. data', 'Regression'),'best',shadow=True)
	## X Title
xl = xlabel(r'\textsf{x title} ($^{\circ}$C)',size='x-large')
	## Y Title
yl = ylabel(r'\textsf{y title} $(\Omega)$',size='x-large')
rangex = max(xdata)-min(xdata);
rangey = max(ydata)-min(ydata);
axis([0, max(xdata)+rangex/2, 0, max(ydata)+rangey/2])	
	# Vypis parametrov fitovania do okna grafu
figtext(.6,.3,r'$y = (%s %.6g)*x$' %(sign,abs(a[0])))
figtext(.6,.25,r'$a = %s%.6g \pm %.6g$' %(sign,abs(a[0]),sa))
figtext(.6,.2,r'$P(\chi^2 \geq \chi^2(0)) = %.6g$' %(pval))
	# Save figure *.png, *.eps
savefig('noint1.eps')
show()
