from scipy import *
from pylab import *
#from numpy import *
from scipy.stats import chi2
matplotlib.rc('text', usetex = True)
expdata = load('e6.dat') # or norris.dat
xdata = expdata[:,0]
ydata = expdata[:,1]
n = len(xdata)
print('')
#print stats.linregress(x,y)#[0:2]
(b,a,r,tt,stderr) = stats.linregress(xdata,ydata)
print b, a
print r
print tt
#norm = sum(power((ydata - (a + b*xdata)), 2)) ## or see next line
norm = power(stderr,2)*n
pval = (1 - chi2.cdf(norm, (n-2)))*100
print pval
print ('norm(chi^2) =', norm)
print ('stderr =', stderr)
#plot(xdata,ydata,'sk', xdata,(a + b*xdata),'-r')
	#
	# Compute the regression coeficient error and mean square error 
	# Ref:
	# 1) John R. Taylor, "An Introduction to Error Analysis", (1st ed., 1982)
	#    Russian translation "Vvedenie v teoriyu oshibok", Moskva, Mir, 1985, p. 166
	# 2) J. Uhrin, L. Sevcovic, J. Murin, "Fyzikalne merania", Kosice, elfa, 2006, p. 129 
	#
msqr = sqrt([sum(((a + b*xdata)-ydata)**2)/(n-2)]) # mean square error; sigma y
print msqr
s0 = sum(((a + b*xdata)-ydata)**2)/(n-2) # yfit = a + b*xdata
s1 = sum(xdata**2)
s2 = sum(xdata)**2
sa = sqrt([(s0*s1)/(n*s1-s2)]) # error of coeficent 'a'
sb = sqrt([(n*s0)/(n*s1-s2)]) # error of coeficient 'b'
# 
if b >= 0:
	sign = '+'
else:
	sign = '-'
# 
print('')
print('Linear regression y = a + b*x using "stats.linregress"')
print('Parameters of regression: a = %.5g +/- %.5g, b = %.5g +/- %.5g, mean sq error= %.5g' %(a,sa,b,sb,msqr))
print('')
	# Matplotlib ploting
title(r'\textsf{Linear Regression}',size='x-large')
plot(xdata,ydata,'ks',xdata,(a + b*xdata),'r-',markersize=6,markeredgecolor='k',\
markerfacecolor='w')
legend(('Exp. data', 'Regression'),'best',shadow=True)
	# X Title
xl = xlabel(r'\textsf{x title} ($^{\circ}$C)',size='x-large')
	# Y Title
yl = ylabel(r'\textsf{y title} $(\Omega)$',size='x-large')
rangex = max(xdata)-min(xdata);
rangey = max(ydata)-min(ydata);
axis([min(xdata)-rangex/10, max(xdata)+rangex/10, min(ydata)-rangey/10, max(ydata)+rangey/10])
	# Vypis parametrov fitovania do okna grafu
figtext(.55,.3,r'$y = %.6g %s (%.5g)*x$' %(a,sign,abs(b)))
figtext(.55,.25,r'$a = %.6g \pm %.5g$' %(a,sa))
figtext(.55,.2,r'$b = %s%.5g \pm %.5g$' %(sign,abs(b),sb))
figtext(.55,.15,r'$P(\chi^2 > \chi^2(0)) = %.5g$' %(pval))
	# Save figure *.png, *.eps
savefig('e6.eps') # or norris.eps
show()
