##
z <- 4 * volcano        # Exaggerate the relief
x <- 10 * (1:nrow(z))   # 10 meter spacing (S to N)
y <- 10 * (1:ncol(z))   # 10 meter spacing (E to W)

z0 <- min(z) - 5
z <- rbind(z0, cbind(z0, z, z0), z0)
x <- c(min(x) - 1e-10, x, max(x) + 1e-10)
y <- c(min(y) - 1e-10, y, max(y) + 1e-10)

fill <- matrix("green3", nr = nrow(z)-1, nc = ncol(z)-1)
fill[ , i2 <- c(1,ncol(fill))] <- "gray"
fill[i1 <- c(1,nrow(fill)) , ] <- "gray"

#par(bg = "lightblue",mar=c(.5,.5,2.5,.5))
par(bg = "white",mar=c(2.5,2.5,2.5,2.5))
persp(x, y, z, theta = -42, phi = 25, col = fill, scale = F, axes = F)
title(main = "Maunga Whau\nOne of 50 Volcanoes in the Auckland Region.", font.main =
4)
#
dev.print(pdf, file = "source_25.pdf")
dev.print(postscript, encoding="ISOLatin1.enc", file = "source_25.eps")
