#graphics.off()
#
g <- expand.grid(x = 1:10, y = 5:15, gr = 1:2)
g$z <- log((g$x^g$g + g$y^2) * g$gr)

#par(mfrow=c(2,2))
##
pl1 <- wireframe(z ~ x * y, data = g, groups = gr,
scales = list(arrows = FALSE),
drape = TRUE, colorkey = TRUE,
screen = list(z = 30, x = -60))
##
pl2 <- cloud(Sepal.Length ~ Petal.Length * Petal.Width | Species, data = iris,
screen = list(x = -90, y = 70), distance = .4, zoom = .6)

print(pl1, split=c(1,1,2,2), more=T)
print(pl2, split=c(2,1,2,2), more=T)
dev.print(pdf, file = "3D-plots-2.pdf", family="Helvetica")
