##
library(lattice)
data(iris)
str(iris)
attach(iris)
#
rm(list=ls(all=TRUE))
#dev.off()
#graphics.off()
#X11(display="")
#X11.options(reset = TRUE)
#
## three-dimensional scatterplot
pl1 <- cloud(Sepal.Length~Petal.Length*Petal.Width, groups=Species, data=iris,
pch=20, screen=list(z=20, x=-60), main="Scatter plot")

## wireframe for 3D surfaces (similar to 'persp' plots), 87x61 matrix
data(volcano)
pl2 <- wireframe(volcano, shade=F, aspect=c(61/87, 0.4), light.source=c(10, 0,
10), zoom=1.1, box=F, scales=list(draw=F), xlab="", ylab="", main="Wireframe plot")

## creating level plots (similar to 'image' plots)
pl3 <- levelplot(volcano, col.regions=gray(0:16/16), main="Level plot")

## contour plots
pl4 <- contourplot(volcano, at=seq(floor(min(volcano)/8)*10, ceiling(max(volcano)/
8)*10, by=10), main="Contour plot", sub="contour interval 10m", region=T,
col.regions=terrain.colors(100))
#
print(pl1, split=c(1,1,2,2), more=T)
print(pl2, split=c(2,1,2,2), more=T)
print(pl3, split=c(1,2,2,2), more=T)
print(pl4, split=c(2,2,2,2), more=T)
dev.print(pdf, file = "3D-plots.pdf", family="Helvetica")
