#
# Find the Least Squares Fit
# The least squares estimate of *b* in the model y = X b + e is found.
#
# Uloha E6 -- Aplimat 2008
#
dataset <- read.table("/home/laco/rvedok/Vzory/R/aplimat/e6.dat",
header=TRUE,
sep="", dec=".")
x <- dataset$x; y <- dataset$y
# fitovanie linearnou funkciou
#fitls <- lsfit(x, y, wt=NULL, intercept=TRUE, tolerance=1e-07, yname=NULL)
fitls <- lsfit(x, y, wt=NULL, intercept=TRUE)
pls <- coef(fitls)
pls
fitlm <- lm(y ~ 1 + x, data=dataset)
plm <- coef(fitlm)
plm
summary(fitls)
summary(fitlm)
# generation of fine 'x'
xfit <- seq(0,100,0.01)
yfitl <- plm[1] + plm[2] * xfit
# fitovanie polynomom druheho stupna
fitp <- lm(y ~ 1 + x + I(x^2))
ppoly <- coef(fitp)
yfitp <- ppoly[1] + ppoly[2]*xfit + ppoly[3]*xfit^2
# grafika
par(mfrow=c(2,2))
# plot data
plot(x, y, pch=20, bty="n7")
#box(which = "plot", lty = 1, col="red")
title(" plot e6.dat")
# plot optimization
plot(x,y,pch=22,xlab="x axis",ylab="y axis",xlim=c(0,100),ylim=c(80,150),bty="o")
abline(fitlm,col=2)
#lines(xfit, yfitl, col=2)
lines(xfit, yfitp, col=4, lty=3)
title(" linear optimization e6.dat")
legend("topleft", c("data","linefit","polyfit"),lty=c("blank","solid","dotted"),
pch=c(0,NA,NA), col=c("black","red","blue"), bg="gray95")# title="LEGEND"
# plot residulals of poly fit
plot(x, residuals(fitp), pch=20, col=4, main="residuals of polyfit")
# plot(fitted(fitp), residuals(fitp))
abline(h=0, v="", col="green") # line only in x-direction
# plot residuals of linear fit
plot(x, residuals(fitlm), pch=20, col=2, main="residuals of linefit", type="p")
# box(lty =1, col="red")
# plot(fitted(fitlm), residuals(fitp))
abline(h=0, v="", col="green") # line only in x-direction
dev.print(pdf,file =
"/home/laco/rvedok/Vzory/R/aplimat/e6-aplimat.pdf")
# zapis vysledkov do suboru
boxl <- summary(fitlm)
parl <- boxl$coef[,]
write.table(parl,file="/home/laco/rvedok/Vzory/R/aplimat/e6-lm-par.txt")
boxp <- summary(fitp)
parp <- boxp$coef[,]
write.table(parp,file="/home/laco/rvedok/Vzory/R/aplimat/e6-p-par.txt")
# computes a table of analysis of variance or deviance
# for one 'aov()' or several models 'anova()'
aov(fitlm)
aov(fitp)
# compare two models...
# compare a submodel with an outer model
# and produce an analysis of variance table
anova(fitlm,fitp)#,test = c("Chisq"))
# compute the Akaike information criterion
AIC(fitlm,fitp)
# Sum of Squares ~ Chi^2
chisqrp <- deviance(fitp)
chisqrp
# Sum of Squares ~ Chi^2
chisqrl <- deviance(fitlm)
chisqrl
