require(stats)
# simplest form of fitting a first-order model to these data
fm1 <- nls(demand ~ A*(1-exp(-exp(lrc)*Time)), data = BOD,
   start = c(A = 20, lrc = log(.35)))
coef(fm1)
print(fm1)
# using the plinear algorithm
fm2 <- nls(demand ~ (1-exp(-exp(lrc)*Time)), data = BOD,
   start = c(lrc = log(.35)), algorithm = "plinear", trace = TRUE)
# using a self-starting model
fm3 <- nls(demand ~ SSasympOrig(Time, A, lrc), data = BOD)
summary( fm3 )
tt <- seq(1, 7, length.out = 100)
plot(demand ~ Time, data = BOD)
lines(tt, predict(fm2, list(Time = tt)), lty = 1, col = 2)
legend(4, 12, c("BOD data", "nls fit"), col = c("black","red"), lty = c(NA,1), pch =
c(1,NA))
#
dev.print(pdf, file = "/home/laco/rvedok/Vzory/R/aplimat/bod-data.pdf")
