dataset <- read.table("/home/laco/rvedok/Vzory/R/aplimat/bulkdy1.dat", header=TRUE,
sep="",
na.strings="NA", dec=".", strip.white=TRUE)
x <- dataset$x; y <- dataset$y
##
par(mfrow=c(2,1))
plot(x,y, xlab="Temperature", ylab="Resistance", pch=0,
main="BulkDy Data - Smooth.spline")
bulk.splajn <- smooth.spline(x,y,df=20)
lines(bulk.splajn, col="red",lty=1)
#
#lines(pp <- predict(bulk.splajn, x), col = "red")
#plot(pp$x, diff.quot(pp$x,pp$y), type = 'l', col="blue")
#lines(pd <- predict(bulk.splajn, x, deriv = 1), col="blue")
pd <- predict(bulk.splajn, x, deriv = 1)
Temperature <- pd$x; Derivatives <- pd$y
#
xfine <- seq(min(x),max(x),by=0.2)
pdfine <- predict(bulk.splajn, xfine, deriv = 1)
Derivfine <- pdfine$y
plot(Temperature, Derivatives)
lines(der.splajn <- smooth.spline(xfine, Derivfine,df=100),col="blue",lty=1)
title("BulkDy Data - Derivative")

#dev.print(postscript, file = "/home/laco/rvedok/Vzory/R/aplimat/bulkdysmooth.eps",
#family="ComputerModern")
dev.print(pdf, file = "/home/laco/rvedok/Vzory/R/aplimat/bulkdysmooth.pdf",
family="Helvetica")
dev.print(png, file="/home/laco/rvedok/Vzory/R/aplimat/bulkdysmooth.png",
width=480, height=640)

par(mfrow=c(1,1))
#
#rm(list=ls(all=TRUE))
minder <- which.min(pdfine$y)
minx <- min(pdfine$x)
mintemp <- minx + 0.2*(minder-1)
write.table(pdfine,file="bulk-deriv-splajn.txt",row.name=TRUE,col.name=TRUE)
write(mintemp,file="bulk-mintemp.txt")
mintemp
rm(list=ls(all=TRUE))

