#
# nls
#
# Determine the nonlinear least-squares estimates of the nonlinear
# model parameters and return a class 'nls' object.
#
#dataset <-
#read.table("/home/laco/rvedok/Vzory/R/aplimat/ohm2.dat", header=TRUE, sep="",
#dec=".")
dataset <-
read.table("ohm2.dat", header=T, sep="", dec=".")
#
x <- dataset$x; y <- dataset$y
#nls.control(maxiter=1000, tol=1e-6, minFactor=1/2048)
out.1 <- nls(y~a/(b+x), start=c(a=5000, b=15))
par1 <- coef(out.1)
#
xfit <- seq(2,130,0.1)
yfit1 <- par1[1]/(par1[2]+xfit)
#
par(mfrow=c(2,1))
# (1,1)
plot(x, y, ylim=c(40,350), pch=0, xlab="x axis",ylab="y axis", main="Ohmov zakon")
lines(xfit, yfit1, col="red")
lines(xfit, 6800/(20.25+xfit), col="blue", lty=3)
# title(" nonlinear optimization ohm2.dat")
legend(60, 340,
c("data","fit: y = a/(b+x)","ohm's predict: a=6800, b=20.25"),
lty=c("blank","solid","dotted"),
pch=c(0,NA,NA), col=c("black","red","blue"), bg="gray95")# title="LEGEND"
# a <- 6800; b <- 20.25; f <- function(x) a/(b+x)
# plot(f, xlim=c(0,130), type='l')
#title("nonlinear optimization: keltt1rint.dat")
# (2,1)
plot(x, residuals(out.1), col="red",pch=20, main="Rezidua",
xlab=expression(paste(nu)))
lines(x, 6800/(20.25+x)-y,type="p", col="blue",pch=20)
legend(80, 1.6,
c("fit: y = a/(b+x)","ohm's predict"),pch=c(20,20),col=c("red","blue"), bg="gray95")
abline(h=0, v="", col="green") # line only in x-direction
#
dev.print(postscript, file = "/home/laco/rvedok/Vzory/R/aplimat/ohm2-aplimat.eps")
dev.print(pdf, file = "/home/laco/rvedok/Vzory/R/aplimat/ohm2-aplimat.pdf")
#dev.print(png, file = "/home/laco/rvedok/Vzory/R/aplimat/ohm2-aplimat.png",
#width=480, height=640)
##
#rm(list=ls(all=TRUE))
#ls()
out.1
summary(out.1)
rezid <- residuals(out.1)
confint(out.1)
conf.int <- confint(out.1)
predict(out.1)
pre.dict <- predict(out.1)
#lines(x, predict(out.2), col="blue")
#?nls
##
#names(box)	# 'names()' The Names Attribute of an Object
# Description: functions to get or set the names of an object.
#box$parameters[1,1] # same as [1]
#box$parameters[2,1] # same as [3]
#box$parameters[1,2] # same as [2]
#box$parameters[2,2] # same as [4]
#box$parameters[,]
##
box1 <- summary(out.1)
pars1 <- box1$parameters[,] # short form box1$param[,]
# same as
# pars1 <- box1$coefficients[,] # short form box1$coef[,]
write.table(pars1,file="/home/laco/rvedok/Vzory/R/aplimat/ohm1-aplimat-par1.txt")
write.table(conf.int,
file="/home/laco/rvedok/Vzory/R/aplimat/ohm1-aplimat-confint.txt")
write.table(pre.dict,
file="/home/laco/rvedok/Vzory/R/aplimat/ohm1-aplimat-predict.txt")
write.table(rezid,file="/home/laco/rvedok/Vzory/R/aplimat/ohm1-aplimat-rezid.txt")
#write.table(pars,file="data_pars.txt")
#write.csv(par2, file = "data.csv")
##
#write.table(summary(out.2),file="t1rokelt_par.txt")
##
#write(x, file = "data.txt", ncolumns = if(is.character(x)) 1 else 14,
#append = FALSE, sep = " ")
##
#write.table(dataset, file = "data.txt", append = FALSE, quote = TRUE, sep = " ",
#eol = "\n", na = "NA", dec = ".", row.names = FALSE,
#col.names = TRUE, qmethod = c("escape", "double"))
##
# legend(locator(1), as.character(0:20), pch=0:20)
# legend("bottomleft","NA" ,as.character(0:20), pch=0:20)
##
# compute the Akaike information criterion
AIC(out.1)

