#
# Fitting Linear Models
# 'lm' is used to fit linear models. It can be used to carry out
# regression, single stratum analysis of variance and analysis of
# covariance (although 'aov' may provide a more convenient interface
# for these).
#
## Uloha G1
dataset <- read.table("/home/spolocne/Vzory/R/linreg/g1.dat", header=TRUE, sep="", na.strings="NA", dec=".", strip.white=TRUE)
LMg1 <- lm(y  ~ 0 + x , data=dataset)
g1 <- coef(LMg1)
plot(dataset, pch=22, xlab="x axis", ylab="y axis",xlim=c(0,1.4), ylim=c(0,6))
xfit <- seq(0,1.4,0.01)
yfit <- g1[1] * xfit
lines(xfit, yfit, col=2) 
lines(dataset$x, fitted(LMg1), col="blue")
dev.print(pdf,file = "/home/spolocne/Vzory/R/linreg/g1lm.pdf", family="Times")
summary(LMg1)
## Sum of Squares ~ Chi^2 
ChisqrL <- deviance(LMg1)
ChisqrL
# Result from Qtiplot: Chi^2/doF = 0.0236391
# doF = n-p = 9
# Chi^2 = 0.2127519

