#
# Fitting Linear Models
# 'lm' is used to fit linear models. It can be used to carry out
# regression, single stratum analysis of variance and analysis of
# covariance (although 'aov' may provide a more convenient interface
# for these).
#
## Louis Lyons data
dataset <- read.table("/home/spolocne/Vzory/R/linreg/lyons.dat", header=TRUE, sep="", na.strings="NA", dec=".", strip.white=TRUE)
x <- dataset$x; y <- dataset$y; s <- dataset$sig
fitw <- lm(y  ~ 1 + x, data=dataset, weights=1/s^2)
plyow <- coef(fitw) 
plyow
##
summary(fitw)
##
fit <- lm(y  ~ 1 + x, data=dataset, weights=NULL)
plyo <- coef(fit) 
plyo
##
summary(fit)
##
plot(x,y,xlim=c(-2,4),ylim=c(2,3.6), pch=0)
xfit <- seq(-2,4,0.01)
yfit <- plyo[1] + plyo[2] * xfit 
#lines(xfit, yfit, col=2)
abline(fitw, col=2) # could also type abline(plyo[1], plyo[2], col=2)
title("Worked example of straight line fit - Louis Lyons")
dev.print(pdf, "/home/spolocne/Vzory/R/linreg/lyonslmw.pdf")
##
## Weighted fit residuals
##
plot(residuals(fitw),pch=15)
abline(h=0,col="blue")
dev.print(pdf, "/home/spolocne/Vzory/R/linreg/lyonslmrw.pdf")
##
## Unweighted fit residuals
##
plot(residuals(fit),pch=15)
abline(h=0,col="blue")
dev.print(pdf, "/home/spolocne/Vzory/R/linreg/lyonslmrunw.pdf")
##
aov.lyons <- aov(y ~ 1 + x, data=dataset)
summary(aov.lyons)
search()
names(aov.lyons)
aov.lyons$coefficients

