#
# Find the Least Squares Fit
# The least squares estimate of *b* in the model y = X b + e is found.
#
## Louis Lyons data
dataset <- read.table("/home/spolocne/Vzory/R/linreg/lyons.dat", header=TRUE, sep="", na.strings="NA", dec=".", strip.white=TRUE)
x <- dataset$x; y <- dataset$y; s <- dataset$sig
fitw <- lsfit(x, y, wt=1/s^2, intercept=TRUE, tolerance=1e-07, yname=NULL)
plyow <- coef(fitw) 
plyow
##
fit <- lsfit(x, y, wt=NULL, intercept=TRUE, tolerance=1e-07, yname=NULL)
plyo <- coef(fit) 
plyo
##
plot(x,y,xlim=c(-2,4),ylim=c(2,3.6), pch=0)
xfit <- seq(-2,4,0.01)
yfit <- plyo[1] + plyo[2] * xfit 
#lines(xfit, yfit, col=2)
abline(fitw, col=2) # could also type abline(plyo[1], plyo[2], col=2)
title("Worked example of straight line fit - Louis Lyons")
dev.print(pdf, "/home/spolocne/Vzory/R/linreg/lyonslsw.pdf")
##
## Weighted fit residuals
##
plot(residuals(fitw),pch=15)
abline(h=0,col="blue")
dev.print(pdf, "/home/spolocne/Vzory/R/linreg/lyonslsrw.pdf")
##
## Unweighted fit residuals
##
plot(residuals(fit),pch=15)
abline(h=0,col="blue")
dev.print(pdf, "/home/spolocne/Vzory/R/linreg/lyonslsrunw.pdf")
##
aov.lyons <- aov(y ~ 1 + x, data=dataset)
summary(aov.lyons)
search()
names(aov.lyons)
aov.lyons$coefficients

