#
# Fitting Linear Models
# 'lm' is used to fit linear models. It can be used to carry out
# regression, single stratum analysis of variance and analysis of
# covariance (although 'aov' may provide a more convenient interface
# for these).
#
## NIST noint1.dat
expdata <- read.table("/home/spolocne/Vzory/R/linreg/noint1.dat", header=TRUE, sep="", na.strings="NA", dec=".", strip.white=TRUE)
#plot(expdata)
#summary(expdata)
x <- expdata$x; y <- expdata$y
fitm <- lm(y ~ 0 + x)
par <- coef(fitm)
xfit <- seq(0,70,0.01)
yfit <- par[1] * xfit
##
plot(x, y, xlim=c(0,70), ylim=c(0,140), pch=22, xlab="x axis", ylab="y axis")
lines(xfit, yfit, col=2)
title(" Linear optimization - NIST noint1.dat")
legend("topleft", c("perfect fit"), lty=1, col="red", title="LEGEND",bg="gray95")
dev.print(pdf, file = "/home/spolocne/Vzory/R/linreg/noint1.pdf", family="Times")
summary(fitm)

