##
graphics.off()
rm(list=ls(all=TRUE))
#
dataset <- read.table(
#url("http://people.tuke.sk/ladislav.sevcovic/esf/data/keltt1rint.dat"),
"153.dat", header=TRUE, sep="", dec=".")
#
x <- dataset$x; y <- dataset$y
xfit <- seq(0.1,96,0.01)

par(mfrow=c(2,2))

# vykreslenie diferencialneho zaznamu ciary cwJMR
zakl <- mean(y)
plot(x, y, pch=22, xlab="x", ylab="y", col="black", main="cwNMR signal", cex=.7,
cex.axis=1, cex.lab=1.5, cex.main=1.8, font=2, family="")
abline(h=zakl, v="", col="red", lty=2)

# (1) numericka integracia dif. ciary cwJMR
y.int <- -(y - zakl*matrix(1,nrow=1024))
for (i in 2:1024) {
	y.int[[i]] <- y.int[[i-1]] + y.int[[i]]
}

# (2) numericka integracia dif. ciary cwJMR
integ <- matrix(0,nrow=length(y)+1)
for (i in 1:length(y)+1) {
	for (j in 2:i-1) {
	integ[[i]] <- integ[[i]] - y[[j]] + zakl
	}
}

# (1) vykreslenie integralneho tvaru ciary cwJMR
plot(x, y.int, type="l", col="blue", cex.axis=0.8,
main=expression(paste("Integralny tvar cwNMR signalu:  ",
y.int==integral(y * dx))), cex.main=1)
abline(h=0, v="", col="red", lty=2)

# integrovanie funkcie...
xv <- seq(0, 10, 0.1)
integrand <- function(x) {1/((1+x)*sqrt(x))}
integrate(integrand, lower=0, upper= Inf)
plot(xv, integrand(xv), type="l", col="red",
main=expression(paste("Integral ", integral(frac(dx,(1+x)*sqrt(x)),
0, infinity), " = 3.141593")), cex.main=0.9)
text(4, 2, expression(f(x)==frac(1,(1+x)*sqrt(x))), col="blue")
#sub=expression(paste(frac(1,(1+x)*sqrt(x)))), cex.sub=0.6

# (2) vykreslenie integralneho tvaru ciary cwJMR
plot(1:length(integ), integ, type="l", col="red")
abline(h=0, v="", col="blue", lty=2)

#
dev.print(pdf, file = "153-integrovanie.pdf")
dev.print(postscript, encoding="ISOLatin1.enc", file = "153-integrovanie.eps")
