#
# nlm
#
# This function carries out a minimization of the function 'f' using
# a Newton-type algorithm.
# 
x <- c(0.02, 0.02, 0.06, 0.06, 0.11, 0.11, 0.22, 0.22, 0.56, 0.56, 1.10, 1.10)
y <- c(76, 47, 97, 107, 123, 139, 159, 152, 191, 201, 207, 200)
fn <- function(p) sum((y - (p[1] * x)/(p[2] + x))^2)
plot(x, y)
xfit <- seq(.02, 1.1, .05)
yfit <- 200 * xfit/(0.1 + xfit)
ln<-lines(spline(xfit, yfit))
#lg1<-legend("bottomright", "(x,y)", pch=1, title="bottomright")
#lg2<-legend("bottom", "(x,y)", pch=1, title="bottom")
## 
#rm(lg1, lg2)
out <- nlm(fn, p = c(200, 0.1), hessian = TRUE)
sqrt(diag(2*out$minimum/(length(y) - 2) * solve(out$hessian)))
postscript(file = "/home/spolocne/Vzory/R/nonlinreg/bates_wats.eps", family = c("ComputerModern"))
plot(x, y)
xfit <- seq(.02, 1.1, .05)
yfit <- 212.68384222 * xfit/(0.06412146 + xfit)
yfit2 <- out$estimate[1] * xfit/(out$estimate[2] + xfit)
lines(spline(xfit, yfit2))
title("Bates - Wats nonlinear optimization")
dev.off()
out$estimate
out
#> out
#$minimum
#[1] 1195.449

#$estimate
#[1] 212.68384222   0.06412146

#$gradient
#[1] -0.0001535012  0.0934206673

#$hessian
#            [,1]        [,2]
#[1,]    11.94725   -7661.319
#[2,] -7661.31875 8039421.153

#$code
#[1] 3

