#
# nls, nlm
#
# Determine the nonlinear least-squares estimates of the nonlinear
# model parameters and return a class 'nls' and 'nlm' objects.
#
# rm(list=ls(all=TRUE))
rm(list=ls())
#dataset <-
#read.table("/home/laco/rvedok/Vzory/R/aplimat/keltt1rint.dat", header=TRUE, sep="",
#dec=".")

dataset <- read.table(
#url("http://people.tuke.sk/ladislav.sevcovic/esf/data/keltt1rint.dat"), 
"bonate.dat", header=TRUE, sep="", dec=".")
#
x <- dataset$x; y <- dataset$y
xfit <- seq(0.1,96,0.01)
we <- 1/y # weighting
#nls.control(maxiter=1000, tol=1e-6, minFactor=1/2048)

out.1 <- nls(y~a*exp(-x*b), start=c(a=200, b=.1))
out.2 <- nls(y~a*exp(-x*b)+c*exp(-x*d), start=c(a=200, b=.1, c=50, d=.01))
##
## weighted one exp nonlinear model 
fw <- function(p){
sum(we*(y - p[1]*exp(-x*p[2]))^2)
}
out.w <- nlm(fw, p=c(200, 1), hessian = TRUE)
yfitw <- out.w$estimate[1] * exp(- xfit*out.w$estimate[2])
yestw <- out.w$estimate[1] * exp(- x*out.w$estimate[2])
p <- length(out.w$estimate[]) # No. of estimated parameters
sew <- sqrt(abs(diag(2*out.w$minimum*solve(out.w$hessian))/(length(y)-p)))
##
## weighted two exp nonlinear model 
f2w <- function(p) sum(we*(y - (p[1]*exp(-x*p[2]) + p[3]*exp(-x*p[4])))^2)
out2.w <- nlm(f2w, p=c(200, .1, 50, .01), hessian = TRUE)
yfit2w <- out2.w$estim[1] * exp(- xfit*out2.w$estim[2]) + out2.w$estim[3] *
exp(- xfit*out2.w$estim[4])
yest2w <- out2.w$estim[1] * exp(- x*out2.w$estim[2]) + out2.w$estim[3] *
exp(- x*out2.w$estim[4])
p2 <- length(out2.w$estim[]) # No. of estimated parameters
se2w <- sqrt(abs(diag(2*out2.w$minimum*solve(out2.w$hessian))/(length(y)-p2)))
