#
# nls
#
# Determine the nonlinear least-squares estimates of the nonlinear
# model parameters and return a class 'nls' object.
#
dataset <- read.table("/media/hda8/kurz_rvedok/Vzory/bonate.dat",
header=TRUE,
sep="", na.strings="NA", dec=".", strip.white=TRUE)
x <- dataset$x; y <- dataset$y

#nls.control(maxiter=1000, tol=1e-6, minFactor=1/2048)
out.1 <- nls(y~a*exp(-x*b), start=c(a=200, b=.1))
out.2 <- nls(y~a*exp(-x*b)+c*exp(-x*d), start=c(a=200, b=.1, c=50, d=.01))

par1 <- coef(out.1)
par2 <- coef(out.2)

xfit <- seq(0.1,96,0.01)
yfit1 <- par1[1] * exp(- xfit*par1[2])
yfit2 <- par2[1] * exp(- xfit*par2[2]) + par2[3] * exp(- xfit*par2[4])

par(mfrow=c(2,2))
# (1,1)
plot(x, y, pch=0, main="y = a*exp(-x*b)")
lines(xfit, yfit1, col=2)
# (1,2)
plot(x, y, pch=0, main="y = a*exp(-x*b)+c*exp(-x*d)")
lines(xfit, yfit2, col=2)
# (2,1)
plot(x, residuals(out.1))
abline(h=0, v="", col="blue") # line only in x-direction
# (2,2)
plot(x, residuals(out.2))
abline(h=0, v="", col="blue") # line only in x-direction
#
dev.print(pdf, file = "/media/hda8/kurz_rvedok/Vzory/bonate_nls.pdf",
family="Courier")
##
#rm(list=ls(all=TRUE))
#ls()
#out.1
#
na.1 <- summary(out.1) #out.2
m0 <- coef(na.1)[1] # same as m0 <- na.1$parameters[1,1]
sm0 <- coef(na.1)[3]
t1 <- coef(na.1)[2]
st1 <- coef(na.1)[4]
#
na.2 <- summary(out.2)
m0a <- coef(na.2)[1] # same as m0a <- na.2$parameters[1,1]
sm0a <- coef(na.2)[5]
t1a <- coef(na.2)[2]
st1a <- coef(na.2)[6]
m0b <- coef(na.2)[3] # same as m0b <- na.2$parameters[1,1]
sm0b <- coef(na.2)[7]
t1b <- coef(na.2)[4]
st1b <- coef(na.2)[8]
#
box1 <- summary(out.1)
box2 <- summary(out.2)
pars1 <- box1$parameters[,]
pars2 <- box2$parameters[,]
#
pars1 <- format(pars1, digits=8, sci=TRUE)
write.table(pars1,file="/media/hda8/kurz_rvedok/Vzory/bonate_par1.txt")
#residuals(out.1)
#anova(out.1, out.2)
#confint(out.2)
#predict(out.2)
#lines(x, predict(out.2), col="blue")
#?nls



