#
# optim
#
# Determine the nonlinear least-squares estimates of the nonlinear
# model parameters and return a class 'optim' object.
#
dataset <- read.table("/media/hda8/kurz_rvedok/Vzory/bonate.dat",
header=TRUE, sep="", na.strings="NA", dec=".", strip.white=TRUE)
x <- dataset$x; y <- dataset$y
xfit <- seq(0.1,96,0.01)
we <- 1

fn <- function(p) sum(we*(y - p[1]*exp(-x*p[2])+p[3]*exp(-x*p[4]))^2)
out.o <- optim(c(50, 0.01, 200, 0.1), fn, hessian = TRUE, method=c("Nelder-Mead"))
##
yfit <- out.o$par[1]*exp(-xfit*out.o$par[2])+out.o$par[3]*exp(-xfit*out.o$par[4])
yest <- out.o$par[1]*exp(-x*out.o$par[2])+out.o$par[3]*exp(-x*out.o$par[4])
se <- sqrt(diag(2*out.o$value*solve(out.o$hessian)/(length(y)-4)))
#se2 <- sqrt(diag(2*out.o$value/(length(y)-4)*solve(out.o$hessian)))
##
par(mfrow=c(1,2))
# (1,1)
plot(x, y, pch=0, main="y = a*exp(-x*b)+c*exp(-x*d)")
lines(xfit, yfit, col=2)
# (1,2)
plot(x, y-yest)
abline(h=0, v="", col="blue") # line only in x-direction
#
dev.print(pdf, file = "/media/hda8/kurz_rvedok/Vzory/bonate_optim.pdf",
family="Courier")
##
#rm(list=ls(all=TRUE))
#ls()
#out.1
#
optimpar<-out.o$par[]
summary(out.o)
out.o$par[]
se
out.o$value
pars1 <- format(optimpar, digits=8, sci=TRUE)
write.table(pars1,file="/media/hda8/kurz_rvedok/Vzory/bonate_optim_par1.txt")
#rm(list=ls())
