#
# nlm
#
# This function carries out a minimization of the function 'f' using
# a Newton-type algorithm.
# 
## NIST boxbod.dat
expdata <- read.table("boxbod.dat", header=TRUE, sep="", na.strings="NA", dec=".", strip.white=TRUE)
#plot(expdata)
#summary(expdata)
x <- expdata$x; y <- expdata$y
fnc <- function(p) sum((y - p[1]*(1-exp(-p[2]*x)))^2)
out <- nlm(fnc, p=c(200, 0.75), hessian=TRUE)
se <- sqrt(diag(2*out$minimum*solve(out$hessian))/(length(y)-2))
xfit <- seq(1,10,0.01)
yfit <- out$estimate[1] * (1 - exp(- out$estimate[2] * xfit))
##
plot(x,y)
lines(xfit, yfit, col="red")
title(" Nonlinear optimization - NIST boxbod.dat")
legend(6,160, c("perfect fit"),lty=1, title="LEGEND",bg="gray95")
dev.print(pdf, file = "boxbod_nlm.pdf", family="Times")
#out$estimate
out
se

