#
# nls
#
# Determine the nonlinear least-squares estimates of the nonlinear
# model parameters and return a class 'nls' object.
#
rm(list=ls())
#
# NIST boxbod.dat
expdata <- read.table("boxbod.dat", header=TRUE, sep="", na.strings="NA", dec=".",
strip.white=TRUE)
#plot(expdata)
#summary(expdata)
x <- expdata$x; y <- expdata$y
out <- nls(y~a*(1-exp(-b*x)), start=c(a=100, b=1))
par <- coef(out)
xfit <- seq(1,10,0.01)
yfit <- par[1] * (1 - exp(- par[2] * xfit))
##
plot(x, y, xlab="x axis", ylab="y axis", pch=22) # or matplot()
#plot(x, y, type="l", col="blue", main = "points with bg & legend(*, pt.bg)")
#points(x, y, pch=21, bg="white")
#abline(out$coef,lty=1)
lines(xfit, yfit, col=2) # "red"
title(" Nonlinear optimization - NIST boxbod.dat")
#legend(6,160, c("data"),pch=22, col="black", title="LEGEND",bg="gray95")
#legend(locator(1), c("perfect fit"),lty=1, title="LEGEND",bg="gray95") # "topleft"
legend("topleft", c("perfect fit"), lty=1, col="red", title="LEGEND",bg="gray95")
dev.print(pdf, file = "boxbod_nls.pdf",
family="Times")
#X11()
##
summary(out)
out
fitted(out)
#names(out)
resid(out)
#par(mfrow = c(2, 2))

