##
sapdecay <- read.table("sapdecay.txt", header=T)
attach(sapdecay)
names(sapdecay)
rm(list=ls(all=TRUE))
#rm(list=ls())

par(mfrow=c(2,1))
sumsq <- function(a, xv=x, yv=y)
	{yf <- exp(-a*xv) 
	sum((yv-yf)^2)}

lm(log(y) ~ x)

a <- seq(0.02, 0.25, 0.005)
plot(a, sapply(a, sumsq), type="l", col="blue")

amin <- a[min(sapply(a, sumsq))==sapply(a, sumsq)]
amin

plot(x, y, pch=0)
xv <- seq(0, 50, 0.1)
lines(xv, exp(-amin*xv), col="red")

# minimizes the sum of squares of the residuals
fa <- function(a) sum((y-exp(-a*x))^2)
optimize(fa, c(0.01, 0.1))

# minimizes the sum of the absolute value of the residuals
fb <- function(a) sum(abs(y-exp(-a*x)))
optimize(fb, c(0.01, 0.1))
#
dev.print(pdf, file = "optimalizacia.pdf")
dev.print(postscript, file = "optimalizacia.eps")
