#
# nls
#
# Determine the nonlinear least-squares estimates of the nonlinear
# model parameters and return a class 'nls' object.
#
dataset <- read.table("/home/spolocne/Vzory/R/nonlinreg/t1rokelt.dat", header=TRUE, sep="", na.strings="NA", dec=".", strip.white=TRUE)
x <- dataset$x; y <- dataset$y

out <- nls(y~a*exp(-x/b)+c*exp(-x/d), start=c(a=.6, b=1, c=.4, d=4))
par <- coef(out)

xfit <- seq(0.1,18,0.01)
yfit <- par[1] * exp(- xfit/par[2]) + par[3] * exp(- xfit/par[4])

plot(x, y, pch=0)
lines(xfit, yfit, col=2)
dev.print(pdf, file = "/home/spolocne/Vzory/R/nonlinreg/t1rokelt.pdf", family="Times")



#rm(list=ls(all=TRUE))
#ls()
#out
#summary(out)

