#
# nls
#
# Determine the nonlinear least-squares estimates of the nonlinear
# model parameters and return a class 'nls' object.
#
dataset <- read.table("/home/spolocne/Vzory/R/nonlinreg/t1rokelt.dat",
header=TRUE, sep="", na.strings="NA", dec=".", strip.white=TRUE)
x <- dataset$x; y <- dataset$y

#nls.control(maxiter=1000, tol=1e-6, minFactor=1/2048)
out.1 <- nls(y~a*exp(-x/b), start=c(a=1, b=5))
out.2 <- nls(y~a*exp(-x/b)+c*exp(-x/d), start=c(a=.4, b=2, c=.6, d=5))

par1 <- coef(out.1)
par2 <- coef(out.2)

xfit <- seq(0.1,18,0.01)
yfit1 <- par1[1] * exp(- xfit/par1[2])
yfit2 <- par2[1] * exp(- xfit/par2[2]) + par2[3] * exp(- xfit/par2[4])

par(mfrow=c(2,2))
# (1,1)
plot(x, y, pch=0, main="y = a*exp(-x/b)")
lines(xfit, yfit1, col=2)
# (1,2)
plot(x, y, pch=0, main="y = a*exp(-x/b)+c*exp(-x/d)")
lines(xfit, yfit2, col=2)
# (2,1)
plot(x, residuals(out.1))
abline(h=0, v="", col="blue") # line only in x-direction
# (2,2)
plot(x, residuals(out.2))
abline(h=0, v="", col="blue") # line only in x-direction
#
dev.print(pdf, file = "/home/spolocne/Vzory/R/nonlinreg/t1rokelt_nls.pdf", family="Courier")
##
#rm(list=ls(all=TRUE))
#ls()
out.1
summary(out.1)
out.2
summary(out.2)
#residuals(out.1)
anova(out.1, out.2)
confint(out.2)
predict(out.2)
#lines(x, predict(out.2), col="blue")
#?nls


