#
funky <- function(x) sin(2*pi*x^3)^3
x <- seq(0,1,by=0.01)
y <- funky(x) + 0.1*rnorm(101)
matplot(x,cbind(y,funky(x)),type="pl",ylab="y",pch=18,lty=1)
##
## fitovanie ortogonalnymi polynomami
##
g5 <- lm(y ~ poly(x,5))
g12 <- lm(y ~ poly(x,12))
matplot(x,cbind(y,funky(x),g5$fit,g12$fit),type="plll",ylab="y",pch=18,lty=c(1,2))
dev.print(postscript, file = "/home/spolocne/Vzory/R/splajn/smoothpoly.eps", family ="ComputerModern")
##
## vytvorenie bazy pre B-splajn
##
library(splines)
knots <- c(0,0,0,0,0,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.85,0.9,1,1,1,1)
bx <- splineDesign(knots,x)
gs <- lm(y ~ bx)
##
## plot cubic spline basis function
##
matplot(x,bx,type="l")
##
## plot cubic spline fit
##
matplot(x, cbind(y,gs$fit),type="pl",ylab="y",pch=18,lty=1)
title("B - spline")
dev.print(postscript, file = "/home/spolocne/Vzory/R/splajn/smoothspline.eps", family =
"ComputerModern")
